-- place to keep mount names and their displayID
local mountNames = {72807,51955}

-- create model (which is a frame itself)
local model = CreateFrame("PlayerModel",nil,UIParent)
model:Hide()
model:SetSize(200,200)
model:SetPoint("CENTER")

-- background to the model
model.back = model:CreateTexture(nil,"BACKGROUND")
model.back:SetPoint("TOPLEFT",-4,4)
model.back:SetPoint("BOTTOMRIGHT",4,-4)
model.back:SetTexture(0,0,0,0.5)

-- gather the name and displayID of all mounts on PLAYER_LOGIN
model:SetScript("OnEvent",function()
 -- gather all mount spell names and their displayID
 for i=1,C_MountJournal.GetNumMounts() do
 local _,spellID = C_MountJournal.GetMountInfo(i)
 local mountName = GetSpellInfo(spellID)
 local displayID = C_MountJournal.GetMountInfoExtra(i)
 mountNames[mountName] = displayID
 end
end)
model:RegisterEvent("PLAYER_LOGIN")

-- rotate model while it's visible
local facing,tau = 0,(math.pi*2)
model:SetScript("OnUpdate",function(self,elapsed)
 facing = facing + elapsed/2
 if facing>tau then
 facing = facing-tau
 end
 model:SetRotation(-facing)
end)

-- when the tooltip is shown, if model isn't already visible, see if it should show
GameTooltip:HookScript("OnShow",function()
 -- waiting a frame in case further tooltip handling changes (ie from macro to mount)
 C_Timer.After(0,function() 
 if not model:IsVisible() then
 local name = GameTooltipTextLeft1:GetText()
 local displayID = mountNames[name]
 if displayID then -- if the first line of the tooltip is the name of a mount
 model:SetDisplayInfo(displayID)
 model:SetAnimation(618,-1)
 model:Show()
 end
 end
 end)
end)

-- when tooltip hides, hide model if it was shown
GameTooltip:HookScript("OnHide",function()
 model:Hide()
end)
